/*  A2L parser Stack, Private Headers
    Copyright (C) 2019 Andreas Stewering-Bone

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/**
 * @file cs_a2l_private.h
 * @author Andreas Stewering-Bone
 * @date 9 Dec 2019
 * @brief File containing the A2L private header.
 *
 */

#ifndef CS_A2L_PRIVATE_H
#define CS_A2L_PRIVATE_H

#include "cs_debug.h"
#include "cs_debug_private.h"


#define _a2l_error(...) (cs_error(CS_DEBUG_A2L,__func__,__LINE__,__VA_ARGS__))
#define _a2l_warn(...) (cs_warn(CS_DEBUG_A2L,__func__,__LINE__,__VA_ARGS__))
#define _a2l_info(...) (cs_info(CS_DEBUG_A2L,__func__,__LINE__,__VA_ARGS__))
#define _a2l_debug(...) (cs_debug(CS_DEBUG_A2L,__func__,__LINE__,__VA_ARGS__))
#define _a2l_verbose(...) (cs_verbose(CS_DEBUG_A2L,__func__,__LINE__,__VA_ARGS__))
#define _a2l_error_buffer(DATA,LEN) (cs_error_buffer(CS_DEBUG_A2L,__func__,__LINE__,DATA,LEN))
#define _a2l_warn_buffer(DATA,LEN) (cs_warn_buffer(CS_DEBUG_A2L,__func__,__LINE__,DATA,LEN))
#define _a2l_info_buffer(DATA,LEN) (cs_info_buffer(CS_DEBUG_A2L,__func__,__LINE__,DATA,LEN))
#define _a2l_debug_buffer(DATA,LEN) (cs_debug_buffer(CS_DEBUG_A2L,__func__,__LINE__,DATA,LEN))
#define _a2l_verbose_buffer(DATA,LEN) (cs_verbose_buffer(CS_DEBUG_A2L,__func__,__LINE__,DATA,LEN))
#define _a2l_verbose_binbuffer(DATA,LEN) (cs_verbose_binbuffer(CS_DEBUG_A2L,__func__,__LINE__,DATA,LEN))


#ifdef __cplusplus
extern "C" {
#endif



#ifdef __cplusplus
}
#endif

#endif
