/*  ASC file parser
    Copyright (C) 2015 Andreas Stewering-Bone

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/**
 * @file cs_asc_parser.h
 * @author Andreas Stewering-Bone
 * @date 30 June 2015
 * @brief File containing the ASC parsing API.
 *
 */

#ifndef CS_ASC_PARSER_H
#define CS_ASC_PARSER_H

#include <inttypes.h>
#include <stdio.h>
#include "cs_file_parser.h"
#include "cs_file_parser_private.h"

#ifdef __cplusplus
extern "C" {
#endif

  /** Init Structure
      \retval 1 Failure
      \retval 0 OK
  */
  int cs_asc_parser_open(
			  cs_file_parser_t *data,              /**< Storage structure*/
			  char* filename                      /**< ASC filename*/
			  );

  /**Get one line from ASC file. Next call will get the next line
     \retval 1 Failure, or end of file
     \retval 0 OK
  */ 
  int cs_asc_parser_getentry(
			     cs_file_parser_t *data,          /**< Storage structure*/
			     cs_file_parser_entry_t *entry           /**< Interpreted line*/
			     );

  /** Close structure
      \retval 1 Failure
      \retval 0 OK
  */
  int cs_asc_parser_close(
			  cs_file_parser_t *data           /**< Storage structure*/
			  );

#ifdef __cplusplus
}
#endif

#endif
