/*  cs_dbc_private.h -- Private header for DBC interface
    Copyright (C) 2018 Andreas Stewering-Bone

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#include "cs_lists.h"
#include "cs_defines.h"

/** \struct cs_dbc_node
    DBC bus node definition
*/
struct cs_dbc_node{
  char name[CS_CHARBUF];                    /**< Node name*/
  cs_lists_t genlist;                       /**< Message list, generated by node*/
  cs_lists_t reqlist;                       /**< Message list, requested by node*/
};

/** \struct cs_dbc
    DBC storage structure
*/
struct cs_dbc{
  cs_lists_t nlist;                       /**< Node list*/ 
  cs_lists_t mlist;                       /**< Message list*/
};

