/*  File parser for CAN sniffs
    Copyright (C) 2015 Andreas Stewering-Bone

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/**
 * @file cs_file_parser_private.h
 * @author Andreas Stewering-Bone
 * @date 30 June 2015
 * @brief File containing the private File parsing API.
 *
 */

#ifndef CS_FILE_PARSER_PRIVATE_H
#define CS_FILE_PARSER_PRIVATE_H

#include <inttypes.h>
#include <stdio.h>
#include "cs_file_parser.h"

/** \struct cs_file_parser_t
    Storage structure
*/
struct cs_file_parser{
  FILE* f;           /**< File handle*/
  char *line;        /**< Line pointer*/
  size_t len;        /**< number of lines*/
  void *re;          /**< Regex pointer*/
  cs_file_parser_type_t ftype; /**< File type*/
};


#endif
