/**
 * \file cs_vbf_crc_ccitt.h
 * Functions and types for CRC checks.
 *
 * Generated on Tue Oct 28 11:18:59 2014,
 * by pycrc v0.8.1, http://www.tty1.net/pycrc/
 * using the configuration:
 *    Width        = 16
 *    Poly         = 0x1021
 *    XorIn        = 0x0000
 *    ReflectIn    = False
 *    XorOut       = 0x0000
 *    ReflectOut   = False
 *    Algorithm    = table-driven
 *****************************************************************************/
#ifndef __CS_VBF_CRC_CCITT_H__
#define __CS_VBF_CRC_CCITT_H__

#include "inttypes.h"
#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif


/**
 * The definition of the used algorithm.
 *****************************************************************************/
#define CRC_ALGO_TABLE_DRIVEN 1


/**
 * The type of the CRC values.
 *
 * This type must be big enough to contain at least 16 bits.
 *****************************************************************************/
typedef uint16_t cs_vbf_crc_ccitt_t;


/**
 * Calculate the initial crc value.
 *
 * \return     The initial crc value.
 *****************************************************************************/
#define cs_vbf_crc_ccitt_init()      (0x0000)


/**
 * Update the crc value with new data.
 *
 * \param crc      The current crc value.
 * \param data     Pointer to a buffer of \a data_len bytes.
 * \param data_len Number of bytes in the \a data buffer.
 * \return         The updated crc value.
 *****************************************************************************/
cs_vbf_crc_ccitt_t cs_vbf_crc_ccitt_update(cs_vbf_crc_ccitt_t crc, const unsigned char *data, size_t data_len);


/**
 * Calculate the final crc value.
 *
 * \param crc  The current crc value.
 * \return     The final crc value.
 *****************************************************************************/
#define cs_vbf_crc_ccitt_finalize(crc)      (crc ^ 0x0000)


#ifdef __cplusplus
}           /* closing brace for extern "C" */
#endif

#endif      /* __CS_VBF_CRC_CCITT_H__ */
