#!/usr/bin/python
# -*- coding: utf-8 -*-
# Copyright 2018 by Andreas Stewering-Bone All Rights Reserved.
#
# Permission to use, copy and modify this software and its
# documentation for any purpose and without fee is hereby granted only
# for the customer of the company Ingenieurgemeinschaft IgH.
# ANDREAS STEWERING-BONE and the company IgH DISCLAIMS ALL WARRANTIES 
# WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF 
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
# ANDREAS STEWERING-BONE and the company IgH BE LIABLE FOR ANY SPECIAL, 
# INDIRECT OR CONSEQUENTIAL DAMAGES OR
# ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
# IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
# OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

import cantools
import can
import sys
import math
import time

msignals = list()

scale = 0.1
offset = 0
time_step = 0.1
freq = 0.5
ampl=6

msignals.append(cantools.db.signal.Signal('Testsignal1m', 55, 16, 'big_endian', False, scale=scale, offset=offset,minimum=0.0,maximum=6553.6))
msignals.append(cantools.db.signal.Signal('Testsignal2m', 16, 16, 'little_endian', False, scale=scale, offset=offset,minimum=0.0,maximum=6553.6))
msignals.append(cantools.db.signal.Signal('Testsignale3m', 39, 15, 'big_endian', False, scale=scale, offset=offset,minimum=0.0,maximum=6553.6))
msignals.append(cantools.db.signal.Signal('Time', 0, 16, 'little_endian', True, scale=0.1, offset=0.0,minimum=-6553.6,maximum=6553.6))



node = cantools.db.node.Node('MyNode','MyNodeComment')
nodercv = cantools.db.node.Node('MyReceiver','MyReceiverComment')
bus = cantools.db.bus.Bus('MyBus')

mmessage = cantools.db.message.Message(5, 'TestframeM', 8, msignals,'Comment',['MyNode'])

db = cantools.db.database.Database(messages=[mmessage],nodes=[node],buses=[bus],version='MyVersion')
print db.as_dbc_string()

if len(sys.argv) < 2:
    print("Check arguments")
    print("Call pytestsignalencodingdecoding interface send/recv")
    sys.exit(-1)

iface = sys.argv[1]
direction = sys.argv[2]
ltime = -100.0
    
can.rc['interface'] = 'socketcan_ctypes'
can.rc['channel'] = iface
can_bus = can.interface.Bus()

if direction == 'recv':
    while True:
        rcmessage = can_bus.recv()
        if rcmessage.arbitration_id == mmessage.frame_id:
            print mmessage.decode(rcmessage.data,decode_choices=False, scaling=True)
else:
    vsin =6553.5
    while True:
    
        #vsin = ampl* math.sin(2*math.pi*freq*ltime)
        vsin = vsin -0.1
        if vsin < 0:
            vsin =6553.5
        print ' Time %f: v: %f' %(ltime,vsin)
        data = mmessage.encode({'Testsignal1m': vsin,'Testsignal2m': vsin,'Testsignal3m': vsin,'Time': ltime})
        sendmessage = can.Message(arbitration_id=mmessage.frame_id, data=data)
        can_bus.send(sendmessage)
        
        time.sleep(time_step)
        ltime = ltime + time_step
        
    
